#!/bin/sh

JOBID=$SLURM_JOB_ID
if [ ! -z $SLURM_ARRAY_JOB_ID ]; then
  JOBID="${SLURM_ARRAY_JOB_ID}_${SLURM_ARRAY_TASK_ID}"
fi
if [ "$JOBID" == "" ]; then
  exit 0
fi
CPULINE=$(/opt/slurm-latest/bin/scontrol show job $JOBID -dd 2>&1)
if [ $? -ne 0 ]; then
  exit 0
fi
COMMENT=$(echo -e "$CPULINE" | perl -n -e'/.*Nodes=([\w\-\[\],]+) CPU_IDs=([\w\-,]+) Mem=(\w+) GRES=([\w:\(\)\-,]*).*/ && print "|$1|$2|$4|;"')
UPDATE=$(/opt/slurm-latest/bin/scontrol update job=$JOBID admincomment="$COMMENT" 2>&1)
exit 0
