#!/bin/bash
card_number=1
port_number=1


rm -rf /etc/udev/rules.d/70-persistent-net.rules
rm -rf /etc/udev/rules.d/98-persistent-net.rules
rm -rf /etc/udev/rules.d/99-dhcp-all-interfaces.rules

for dev in $(ip link show | grep mtu | awk -F":" '{print $2}'|xargs); do
  # Check if it is a physical device?
  if [[ -e /sys/class/net/$dev/device/resource ]] && \
     [[ -e /sys/class/net/$dev/speed ]]; then
    # For TP NIC
    ip link set $dev up && dev_speed=$(cat /sys/class/net/$dev/speed) || continue
    dev_speed=$(cat /sys/class/net/$dev/speed)
    if [[ $dev_speed -le 10000 ]] && \
       [[ "$(cat /sys/class/net/$dev/operstate)" == "up" ]]; then
      hwaddress=$(ethtool -P $dev | awk '{print $3}')
      echo -e SUBSYSTEM==\"net\", ACTION==\"add\", DRIVERS==\"?*\", ATTR{address}==\"$hwaddress\", NAME=\"e1p1\" >> /etc/udev/rules.d/98-persistent-net.rules
    # For HIGH SPEED NIC
    elif [[ $dev_speed -ge 10000 ]] && \
         [[ "$(cat /sys/class/net/$dev/device/vendor)" == "0x15b3" ]] && \
         [[ -e /sys/class/net/$dev/device/sriov_numvfs ]]; then
      #echo $dev $card_number $port_number
      if [[ $port_number -gt 2 ]]; then
        card_number=2
        port_number=1
      fi
      hwaddress=$(ethtool -P $dev | awk '{print $3}')
      if [[ "$dev" != "p${card_number}p${port_number}" ]];then
        if [[  "$dev" == "p1p2" ]] || [[ "p${card_number}p${port_number}" == "p1p2" ]];then
          echo 0 > /sys/class/net/$dev/device/sriov_numvfs
        fi
        ip link set $dev down
        ip link set $dev name "p${card_number}p${port_number}"
        dev="p${card_number}p${port_number}"
        ip link set $dev up
      fi
      echo -e SUBSYSTEM==\"net\", ACTION==\"add\", DRIVERS==\"?*\", ATTR{address}==\"$hwaddress\", NAME=\"p${card_number}p${port_number}\" >> /etc/udev/rules.d/98-persistent-net.rules
      port_number=$(( port_number + 1 ))
    fi
  fi
done